#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in ivec4 BoneIDs;
layout(location = 4) in vec4 Weights;




out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
	flat ivec4 BoneIDs0;
	vec4 Weights0;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

const int MAX_BONES = 100;
uniform mat4 gBones[MAX_BONES];

void main() {
	vert.BoneIDs0 = BoneIDs;
    vert.Weights0 = Weights;

	mat4 BoneTransform = mat4(1.0);
	BoneTransform += gBones[BoneIDs[0]] * Weights[0];
    BoneTransform += gBones[BoneIDs[1]] * Weights[1];
    BoneTransform += gBones[BoneIDs[2]] * Weights[2];
    BoneTransform += gBones[BoneIDs[3]] * Weights[3];

	vec4 PosL = BoneTransform * vec4(position, 1);

	vert.normal_world = normalMatrix * normal;
	vert.uv = uv;
	vec4 position_world_ = modelMatrix * PosL;
	//vert.position_world = position_world_.xyz;
	vec4 position_world1_ = modelMatrix * vec4(position, 1);
	vert.position_world = position_world1_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}